'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _each = require('./each');

var _each2 = _interopRequireDefault(_each);

var _options = require('../options');

var _options2 = _interopRequireDefault(_options);

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _utilities = require('./utilities');

var USAGE = 'Usage: chunkify.map(Array array, Function fn, [Object options])';

var map = function map(array, fn) {
  var options = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];

  (0, _utilities.ok_usage)(array, fn, USAGE);
  var okopts = _options2['default'].of(options);
  var mapped = [];
  var pusher = function pusher(result) {
    mapped.push(result);
    return result;
  };
  var mapper = _underscore2['default'].compose(pusher, fn.bind(okopts.scope));
  return (0, _each2['default'])(array, mapper, okopts).then(function () {
    return mapped;
  });
};

exports['default'] = map;
module.exports = exports['default'];