'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _utilities = require('./utilities');

var _loops = require('../loops');

var USAGE = 'Usage: chunkify.each(Array array, Function fn, [Object options])';

var each = function each(array, fn) {
  var options = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];

  (0, _utilities.ok_usage)(array, fn, USAGE);
  return (0, _loops.loop)(function (index) {
    // loop will scope this to options.scope
    return fn.call(this, array[index], index);
  }, array.length, options)['catch'](function (error) {
    // rethrow the error with the array item
    return Promise.reject(_underscore2['default'].extend(error, { item: array[error.index] }));
  });
};

exports['default'] = each;
module.exports = exports['default'];