'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _each = require('./each');

var _each2 = _interopRequireDefault(_each);

var _options = require('../options');

var _options2 = _interopRequireDefault(_options);

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _utilities = require('./utilities');

var USAGE = 'Usage: chunkify.reduce(Array array, Function fn, [Object options])';
var MEMO_KEY = 'memo';

var reduce = function reduce(array, fn) {
  var options = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];

  (0, _utilities.ok_usage)(array, fn, USAGE);
  var initialize = function initialize() {
    if (options.hasOwnProperty(MEMO_KEY)) {
      return { skip_first: false, memo: options[MEMO_KEY] };
    } else {
      return { skip_first: true, memo: array[0] };
    }
  };

  var _initialize = initialize();

  var memo = _initialize.memo;
  var skip_first = _initialize.skip_first;

  var reducee = function reducee(item, index) {
    if (skip_first && index === 0) {
      return;
    }
    // this will be scoped to options.scope
    memo = fn.call(this, memo, item, index, array);
  };
  return (0, _each2['default'])(array, reducee, options).then(function () {
    return memo;
  });
};

exports['default'] = reduce;
module.exports = exports['default'];