'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _range = require('./range');

var _range2 = _interopRequireDefault(_range);

var _options = require('../options');

var _options2 = _interopRequireDefault(_options);

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var USAGE = 'Usage: chunkify.loop(Function fn, Number range, [Object options])';

var ok_usage = function ok_usage(fn, range) {
  if (!_underscore2['default'].isFunction(fn)) {
    throw new Error(USAGE + ' - bad fn; not a function');
  } else if (!_underscore2['default'].isNumber(range)) {
    throw new Error(USAGE + ' - bad range; not a number');
  }
};

var loop = function loop(fn, range) {
  var options = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];

  ok_usage(fn, range);
  delete options.start;
  return (0, _range2['default'])(fn, range, options);
};

exports['default'] = loop;
module.exports = exports['default'];