'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i]; return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var _covenance = require('covenance');

var _frosty = require('frosty');

var _frosty2 = _interopRequireDefault(_frosty);

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var DEFAULTS = {
  chunk: 1,
  delay: 0,
  scope: null
};

var ALIASES = {
  chunk: ['chunksize'],
  delay: ['yield', 'yieldtime', 'delaytime'],
  scope: []
};

var SCHEMA = Object.getOwnPropertyNames(DEFAULTS);

var ChunkifyOptions = (function () {
  _createClass(ChunkifyOptions, [{
    key: 'covenance',
    get: function get() {
      return _covenance.covenance.of({
        attribute: 'chunk',
        validator: function validator(chunk) {
          return _underscore2['default'].isNumber(chunk) && chunk > 0;
        },
        excstring: "'chunk' should be a positive number"
      }, {
        attribute: 'delay',
        validator: function validator(delay) {
          return _underscore2['default'].isNumber(delay) && delay >= 0;
        },
        excstring: "'delay' should be a non-negative number"
      }, {
        attribute: 'scope',
        validator: function validator(scope) {
          if (scope === undefined) {
            return false;
          } else if (_underscore2['default'].isBoolean(scope)) {
            return false;
          } else if (_underscore2['default'].isNumber(scope)) {
            return false;
          }
          return true;
        },
        excstring: "'scope' should be a defined non-boolean and non-number, or null"
      });
    }
  }]);

  function ChunkifyOptions(options) {
    _classCallCheck(this, ChunkifyOptions);

    _underscore2['default'].extend(this, this.constructor._parse_options(options));
    this.check_covenants();
    return this;
  }

  _createClass(ChunkifyOptions, null, [{
    key: '_parse_options',
    value: function _parse_options(options) {
      var parsed = {};
      var setkey = function setkey(key, alias) {
        if (options[alias] === undefined) {
          return false;
        }
        parsed[key] = options[alias];
        return true;
      };
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = SCHEMA[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var key = _step.value;

          if (!setkey(key, key)) {
            var _iteratorNormalCompletion2 = true;
            var _didIteratorError2 = false;
            var _iteratorError2 = undefined;

            try {
              for (var _iterator2 = ALIASES[key][Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                var alias = _step2.value;

                if (setkey(key, alias)) {
                  break;
                }
              }
            } catch (err) {
              _didIteratorError2 = true;
              _iteratorError2 = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion2 && _iterator2['return']) {
                  _iterator2['return']();
                }
              } finally {
                if (_didIteratorError2) {
                  throw _iteratorError2;
                }
              }
            }
          }
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator['return']) {
            _iterator['return']();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      return _underscore2['default'].defaults(parsed, DEFAULTS);
    }
  }, {
    key: 'of',
    value: function of(options) {
      if (options instanceof this) {
        return options;
      }
      var throw_not_an_object = function throw_not_an_object() {
        throw new TypeError('Expected options object, got ' + typeof options);
      };
      if (!_underscore2['default'].isObject(options)) {
        throw_not_an_object();
      } else if (Array.isArray(options)) {
        throw_not_an_object();
      } else if (_underscore2['default'].isFunction(options)) {
        throw_not_an_object();
      }
      return new this(options);
    }
  }]);

  return ChunkifyOptions;
})();

_frosty2['default'].freeze.apply(_frosty2['default'], [ChunkifyOptions.prototype].concat(_toConsumableArray(SCHEMA)));
_covenance.covenance.covenant(ChunkifyOptions);

exports['default'] = {
  of: function of() {
    return ChunkifyOptions.of.apply(ChunkifyOptions, arguments);
  }
};
module.exports = exports['default'];